#include <avr/io.h>
#include <util/delay.h>

#define AREF 5
#define FRECVENTA 1000000

int frecvente_note[7] = {
	523, 587, 659, 698, 783, 880, 987
};

int ADC_get(uint8_t channel)
{
	ADMUX = (ADMUX & ~(0x1f << MUX0)) | channel;

	ADCSRA |= (1 << ADSC);
	while(ADCSRA & (1 << ADSC));

	return ADC;
}

double ADC_voltage(int raw)
{
	return raw * AREF / 1024.;
}

void play()
{
	int perioada;
	int j;
	
	while (1) {
		int i;
		double voltage_value;
		
		for (i = 0; i < 7; i++) {
			voltage_value = ADC_voltage(ADC_get(i));
			
			if (voltage_value > 2.5) {
				perioada_nota = FRECVENTA / frecvente_note[i];
	
				PORTD |= (1 << PD5);
				for (j = 0; j < perioada / 2; j++)
					_delay_us(2);
				
				PORTD &= ~(1 << PD5);
				
				for (j = 0 ; j < perioada / 2; j++)
					_delay_us(2);
			}
		}
	}
}

int main(void) {

	DDRB |= (1 << PD5);
	PORTB &= ~(1 << PD5);
	
	DDRA &= ~(1 << PA1);
	DDRA &= ~(1 << PA2);
	DDRA &= ~(1 << PA3);
	DDRA &= ~(1 << PA4);
	DDRA &= ~(1 << PA5);
	DDRA &= ~(1 << PA6);
	DDRA &= ~(1 << PA7);

	PORTA |= (1 << PA1);
	PORTA |= (1 << PA2);
	PORTA |= (1 << PA3);
	PORTA |= (1 << PA4);
	PORTA |= (1 << PA5);
	PORTA |= (1 << PA6);
	PORTA |= (1 << PA7);

	ADMUX = (1 << REFS0);
	ADCSRA = (1 << ADEN) | (7 << ADPS0);
	
	play();

	return 0;
}
